<?php
class ControllerPaymentPayflowlink extends Controller {
	protected function index() {
		$this->load->language('payment/payflowlink');
		$this->data['action'] = 'https://payflowlink.paypal.com';
		$this->data['MERCHANT'] = $this->config->get('payflowlink_merchant');
		$this->data['PARTNER'] = $this->config->get('payflowlink_partner');
		$this->data['TYPE'] = 'S';
		
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$this->data['order_id'] = $order_info['order_id'];
		$this->data['amount'] = $order_info['total'];
		$this->data['name'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		if (!$order_info['payment_address_2']) {
			$this->data['address'] = $order_info['payment_address_1'];
		} else {
			$this->data['address'] = $order_info['payment_address_1'] . ', ' . $order_info['payment_address_2'];
		}
		$this->data['city']= $order_info['payment_city'];
		$this->data['zip'] = $order_info['payment_postcode'];
		$this->data['state'] = $order_info['payment_zone'];
		$this->data['telephone'] = $order_info['telephone'];
		$this->data['country'] = $order_info['payment_country'];
		$this->data['orderid'] = $this->config->get('config_store') . ' - #' . $order_info['order_id'];
		$this->data['email'] = $order_info['email'];
		$this->data['description'] = "Order ID: ".$order_info['order_id'];
		
    	$this->data['text_credit_card'] = $this->language->get('text_credit_card');
		$this->data['entry_credit_card_type'] = $this->language->get('entry_credit_card_type');
		$this->data['entry_credit_card_number'] = $this->language->get('entry_credit_card_number');
		$this->data['entry_expire_date'] = $this->language->get('entry_expire_date');
		
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
		
		$this->data['cards'] = array();

		$this->data['cards'][] = array(
			'text'  => 'Visa', 
			'value' => 'VISA'
		);

		$this->data['cards'][] = array(
			'text'  => 'MasterCard', 
			'value' => 'MASTERCARD'
		);

		
		$this->data['cards'][] = array(
			'text'  => 'American Express', 
			'value' => 'AMEX'
		);

		
	
		$this->data['months'] = array();
		
		for ($i = 1; $i <= 12; $i++) {
			$this->data['months'][] = array(
				'text'  => strftime(''.$i.'. %B', mktime(0, 0, 0, $i, 1, 2000)), 
				'value' => sprintf('%02d', $i)
			);
		}
		
		$today = getdate();
		
		$this->data['year_valid'] = array();
		
		for ($i = $today['year'] - 10; $i < $today['year'] + 1; $i++) {	
			$this->data['year_valid'][] = array(
				'text'  => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)), 
				'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i))
			);
		}

		$this->data['year_expire'] = array();

		for ($i = $today['year']; $i < $today['year'] + 10; $i++) {
			$this->data['year_expire'][] = array(
				'text'  => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)),
				'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)) 
			);
		}
		
		$this->data['back'] = $this->url->https('checkout/payment');
		
		$this->id       = 'payment';
		$this->template = $this->config->get('config_template') . 'payment/payflowlink.tpl';
		
		$this->render();		
	}

	
	public function confirm() {
	//this needs to first check to make sure response code was 0 = purchase successful//
		$verification = $_REQUEST['RESULT'];
		if($verification=='0'){
		$this->load->model('checkout/order');
		$id = $_REQUEST['USER1'];
		$this->model_checkout_order->confirm($id, $this->config->get('config_order_status_id'));
		}
	}
	

}
?>